//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 
bool flipGreen;

float normalPower <string UIName = "Bumpmap Strength";string UIWidget = "slider";float UIMin = 0.0;float UIMax = 2.0;float UIStep = 0.1;> = 1.0;

Texture2D normalMap <string uiname="normalMap";>;
Texture2D colorTexture <string uiname="Diffuse";>;
Texture2D glossTexture <string uiname="Gloss";>;

SamplerState normalSampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};
TextureCube cubeTex <string uiname="Texture Cube"; >;

SamplerState linearSampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
}; 

cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : VIEWPROJECTION;	
	////////////////////////////////////////////// lamp 1

float3 LightPos1 ;

float4 LightColor1 <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };

float LightIntensity1;

////////////////////////////////////////////// lamp 2

float3 LightPos2 ;

float4 LightColor2 <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };


float LightIntensity2;

////////////////////////////////////////////// surface

float4 AmbiColor <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };

float4 SurfColor <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };

float Kd ;

float Ks ;


float SpecExpon;

float Bumpy ;

float Kr ;


float KrMin ;

float FresExp ;

/////////////////////////////////
};

cbuffer cbPerObj : register( b1 )
{
float4x4 WorldIT : WorldInverseTranspose < string UIWidget = "None"; >;
float4x4 WorldViewProj : WorldViewProjection < string UIWidget = "None"; >;
float4x4 World : World < string UIWidget = "None"; >;
float4x4 ViewInv : ViewInverse < string UIWidget = "None"; >;
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
};

struct VS_IN
{
    half3 Position	: POSITION;
    half4 UV		: TEXCOORD0;
    half4 Normal	: NORMAL;
    half4 Tangent	: TANGENT0;
    half4 Binormal	: BINORMAL0;
};

struct vs2ps
{
    half4 HPosition	: POSITION;
    half4 TexCoord	: TEXCOORD0;
    half4 LightVec1	: TEXCOORD1;
    half3 WorldNormal	: TEXCOORD2;
    half3 WorldPos	: TEXCOORD3;
    half3 WorldEyePos	: TEXCOORD4;
    half3 WorldTangent	: TEXCOORD5;
    half3 WorldBinorm	: TEXCOORD6;
    half4 LightVec2	: TEXCOORD7;
};

vs2ps VS(VS_IN input)
{
    vs2ps OUT = (vs2ps)0;
    OUT.WorldNormal = mul(input.Normal, WorldIT).xyz;
    OUT.WorldTangent = mul(input.Tangent, WorldIT).xyz;
    OUT.WorldBinorm = mul(input.Binormal, WorldIT).xyz;
    half4 Po = half4(input.Position.xyz,1.0);
    half3 Pw = mul(Po, World).xyz;
    OUT.WorldPos = Pw;
    half3 L1 = LightPos1 - Pw;
    half3 L2 = LightPos2 - Pw;
    half Ld1 = 1.0/length(L1);
    half Ld2 = 1.0/length(L2);
    OUT.LightVec1 = half4(L1.xyz,Ld1);
    OUT.LightVec2 = half4(L2.xyz,Ld2);
    OUT.TexCoord = input.UV;
    OUT.WorldEyePos = ViewInv[3].xyz;
    OUT.HPosition = mul(Po, WorldViewProj);
	return OUT;
}




float4 PS(vs2ps In): SV_Target
{
    half3 bumps = Bumpy * (normalMap.Sample(normalSampler,In.TexCoord.xy) * cAmb.xyz-(0.5).xxx);
	half4 map = colorTexture.Sample(normalSampler,In.TexCoord.xy) * cAmb;
	half gloss = Ks * glossTexture.Sample(normalSampler,In.TexCoord.xy).x;
    half3 Nn = normalize(In.WorldNormal);
    half3 Tn = normalize(In.WorldTangent);
    half3 Bn = normalize(In.WorldBinorm);
    half3 Nb = Nn + (bumps.x * Tn + bumps.y * Bn);
    Nb = normalize(Nb);
    half3 Vn = normalize(In.WorldEyePos - In.WorldPos);

    half3 Ln = normalize(In.LightVec1.xyz);
    half3 Hn = normalize(Vn + Ln);
    half hdn = pow(max(0,dot(Hn,Nb)),SpecExpon) * gloss;
    half ldn = dot(Ln,Nb);
    ldn = (In.LightVec1.w* max(0.0,ldn)) * LightIntensity1;
    half4 diffContrib = In.LightVec1.w*(ldn*LightColor1);
    half4 specContrib = In.LightVec1.w*((ldn * hdn) * LightColor1);

    // second lamp
    Ln = normalize(In.LightVec2.xyz);
    Hn = normalize(Vn + Ln);
    hdn = pow(max(0,dot(Hn,Nb)),SpecExpon) * gloss;
    ldn = dot(Ln,Nb);
    ldn = (In.LightVec2.w* max(0.0,ldn)) * LightIntensity2;
    diffContrib = diffContrib + In.LightVec2.w*(ldn*LightColor2);
    specContrib = specContrib + In.LightVec2.w*((ldn * hdn) * LightColor2);

    half3 reflVect = reflect(Vn,Nb);
    half vdn = dot(Vn,Nb);
    half fres = KrMin + (Kr-KrMin) * pow(1-abs(vdn),FresExp);	
	half4 reflColor = fres * cubeTex.Sample(linearSampler,half3(reflVect.x, reflVect.y, reflVect.z));

    half4 result = (SurfColor*map*(Kd*diffContrib+AmbiColor)) + specContrib + reflColor;

	
    return result;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




