//@author: Dottore- ported to dx11 catweasel
//@help: template for standard shaders
//@tags: template
//@credits: 
bool flipGreen;

float normalPower <string UIName = "Bumpmap Strength";string UIWidget = "slider";float UIMin = 0.0;float UIMax = 2.0;float UIStep = 0.1;> = 1.0;

Texture2D normalMap <string uiname="normalMap";>;
Texture2D colorTexture <string uiname="Diffuse";>;
Texture2D glossTexture <string uiname="Gloss";>;

SamplerState normalSampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};
TextureCube cubeTex <string uiname="Texture Cube"; >;

SamplerState linearSampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
}; 

cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : VIEWPROJECTION;	
	////////////////////////////////////////////// lamp 1

float3 LightPos1 ;

float4 LightColor1 <bool color=true;String uiname="LightColor1";> = { 1.0f,1.0f,1.0f,1.0f };

float LightIntensity1;

////////////////////////////////////////////// lamp 2

float3 LightPos2 ;

float4 LightColor2 <bool color=true;String uiname="LightColor2";> = { 1.0f,1.0f,1.0f,1.0f };


float LightIntensity2;

////////////////////////////////////////////// surface

float4 AmbiColor <bool color=true;String uiname="AmbiColor";> = { 1.0f,1.0f,1.0f,1.0f };

float4 SurfColor <bool color=true;String uiname="SurfColor";> = { 1.0f,1.0f,1.0f,1.0f };

float Kd <String uiname="diffuse";float uimin=0.0; float uimax=1.5;> = 1 ;

float Ks <String uiname="specular";float uimin=0.0; float uimax=1.5;> = 1 ;


float SpecExpon <String uiname="Specular Power";float uimin=0.0; float uimax=128;> = 12 ;;

float Bumpy <String uiname="Bumpiness";float uimin=0.0; float uimax=10;> = 1 ;;

float Kr <String uiname="Reflection Max";float uimin=0.0; float uimax=1.5;> = 0.5 ;;


float KrMin <String uiname="Reflection Min";float uimin=0.0; float uimax=.2;> = 0.002 ;  ;

float FresExp <String uiname="Edging";float uimin=0.0; float uimax=7;> = 5 ;   ;
	
	float3 campos;

/////////////////////////////////
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tWVP: WORLDVIEWPROJECTION;
float4x4 WorldIT : WorldInverseTranspose < string UIWidget = "None"; >;
float4x4 WorldViewProj : WorldViewProjection < string UIWidget = "None"; >;
float4x4 World : World < string UIWidget = "None"; >;
float4x4 ViewInv : ViewInverse < string UIWidget = "None"; >;
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
};

struct VS_IN
{
    float4 Position	: POSITION;
    float4 UV		: TEXCOORD0;
    float4 Normal	: NORMAL;
    float4 Tangent	: TANGENT0;
    float4 Binormal	: BINORMAL0;
};

struct vs2ps
{
    float4 HPosition	: POSITION;
    float4 TexCoord	: TEXCOORD0;
    float4 LightVec1	: TEXCOORD1;
    float3 WorldNormal	: TEXCOORD2;
    float3 WorldPos	: TEXCOORD3;
    float3 WorldEyePos	: TEXCOORD4;
    float3 WorldTangent	: TEXCOORD5;
    float3 WorldBinorm	: TEXCOORD6;
    float4 LightVec2	: TEXCOORD7;
	float4 PosWVP: SV_POSITION;
};

vs2ps VS(VS_IN input)
{
    vs2ps OUT = (vs2ps)0;
    OUT.WorldNormal = input.Normal.xyz;//mul(input.Normal, WorldIT).xyz;
    OUT.WorldTangent = input.Tangent.xyz;//mul(input.Tangent, WorldIT).xyz;
    OUT.WorldBinorm = -input.Binormal.xyz;//mul(input.Binormal, WorldIT).xyz;
    float4 Po = float4(input.Position.xyz,1.0);
    float3 Pw = mul(Po, World).xyz;
    OUT.WorldPos = Pw;
    float3 L1 = LightPos1 - Pw;
    float3 L2 = LightPos2 - Pw;
    float Ld1 = 1.0/length(L1);
    float Ld2 = 1.0/length(L2);
    OUT.LightVec1 = float4(L1.xyz,Ld1);
    OUT.LightVec2 = float4(L2.xyz,Ld2);
    OUT.TexCoord = input.UV;
    OUT.WorldEyePos = ViewInv[3].xyz; //ViewInv[3].xyz;
    OUT.HPosition = mul(Po, WorldViewProj);
	OUT.PosWVP  = mul(input.Position,tWVP);
	return OUT;
}




float4 PS(vs2ps In): SV_Target
{
   float3 bumps = Bumpy * (normalMap.Sample(normalSampler,In.TexCoord.xy) * cAmb.xyz-(0.5).xxx);
	float4 map = colorTexture.Sample(normalSampler,In.TexCoord.xy) * cAmb;
	float gloss = Ks * glossTexture.Sample(normalSampler,In.TexCoord.xy).x;
    float3 Nn = normalize(In.WorldNormal);
    float3 Tn = normalize(In.WorldTangent);
    float3 Bn = normalize(In.WorldBinorm);
    float3 Nb = Nn + (bumps.x * Tn + bumps.y * Bn);
    Nb = normalize(Nb);
    float3 Vn = normalize(campos - In.WorldPos);

    float3 Ln = normalize(In.LightVec1.xyz);
    float3 Hn = normalize(Vn + Ln);
    float hdn = pow(max(0,dot(Hn,Nb)),SpecExpon) * gloss;
    float ldn = dot(Ln,Nb);
    ldn = (In.LightVec1.w* max(0.0,ldn)) * LightIntensity1;
    float4 diffContrib = In.LightVec1.w*(ldn*LightColor1);
    float4 specContrib = In.LightVec1.w*((ldn * hdn) * LightColor1);

    // second lamp
    Ln = normalize(In.LightVec2.xyz);
    Hn = normalize(Vn + Ln);
    hdn = pow(max(0,dot(Hn,Nb)),SpecExpon) * gloss;
    ldn = dot(Ln,Nb);
    ldn = (In.LightVec2.w* max(0.0,ldn)) * LightIntensity2;
    diffContrib = diffContrib + In.LightVec2.w*(ldn*LightColor2);
    specContrib = specContrib + In.LightVec2.w*((ldn * hdn) * LightColor2);

    float3 reflVect = reflect(Vn,Nb);
    float vdn = dot(Vn,Nb);
    float fres = KrMin + (Kr-KrMin) * pow(1-abs(vdn),FresExp);	
	float4 reflColor = fres * cubeTex.Sample(linearSampler,float3(reflVect.x, reflVect.y, reflVect.z));

    float4 result = (SurfColor*map*(Kd*diffContrib+AmbiColor)) + specContrib + reflColor;

	
    return result;//float4(In.WorldNormal,1);//result;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




